#delimit;

/* flush memory */
clear;
/* set memory limit */
set mem 50m;

/* go to working directory */
cd "~/Desktop/example-data/";

/* close all open logs */
capture log close;

/* start log using a specified file and format */
log using stata/statalog.smcl, smcl replace;




/*  ********************************************************************** */
/*  ********************************************************************** */
/*  ********************************************************************** */

/* vernnftige Stata-Datenstze herstellen, inkl. reshape und Umrechung */

foreach VariablenNamen in exp_imf_1 exp_imf_2 exp_imf_3 exp_imf_econIV exp_imf_econIII exp_imf_10 exp_imf_11 exp_imf_12 exp_imf_13 exp_imf_14 exp_imf_4 exp_imf_5 exp_imf_6 exp_imf_7 exp_imf_8 exp_imf_9 exp_imf_econ1 exp_imf_econ2 exp_imf_econ4 exp_imf_econ6 exp_imf_econ3-2 exp_imf_econ7-2 exp_imf_econ7-1-1 exp_imf_econ3-5 exp_imf_econ3-3-4 exp_imf_econ3-1 exp_imf_1-3 exp_imf_1-2 exp_imf_1-1 exp_imf_econ7-1 exp_imf_econ3 exp_imf_econ7 exp_imf_econI exp_imf_econII{;

insheet using "data_merged/`VariablenNamen'.txt", delimiter(";") clear names;

/* ... und als Stata-Datensatzabspeichern */
save "data_merged/`VariablenNamen'.dta", replace;

reshape long prefix, i(countrycode) j(year);

/* Umrechnung vorbereiten*/
replace scale =  subinstr(scale,"x10E+12 - 1 d.p.","1000000000000",.);
replace scale = subinstr(scale,"Billions - 0 d.p.","1000000000",.);
replace scale = subinstr(scale,"Billions - 1 d.p.","1000000000",.);
replace scale = subinstr(scale,"Billions - 2 d.p.","1000000000",.);
replace scale = subinstr(scale,"Millions - 0 d.p.","1000000",.);
replace scale = subinstr(scale,"Millions - 1 d.p.","1000000",.);
replace scale = subinstr(scale,"Millions - 2 d.p.","1000000",.);
replace scale = subinstr(scale,"Thousands - 0 d.p.","1000",.);

tabulate scale;


destring scale, replace;


/* Neue Variable mit dem richtigen Namen, inkl. Korrektur - -> _ */
local KorrName = subinstr("`VariablenNamen'","-","_",9);
generate `KorrName' =prefix*scale;

drop series scale prefix code;

/* abspeichern, fertig */
save "data_merged/`VariablenNamen'.dta", replace;

 	}; 
 	
/* Ende loop */

/* labels */






/*  ********************************************************************** */
/*  **************** MERGE THEM ALL in ONE dta-file ********************** */
/*  ********************************************************************** */

/* den ersten ffnen */
use "data_merged/exp_imf_1.dta";
save "stata/stata_new.dta", replace;


/* ber alle, ausser exp_imf_1 */
foreach VariablenNamen in exp_imf_2 exp_imf_3 exp_imf_econIV exp_imf_econIII exp_imf_10 exp_imf_11 exp_imf_12 exp_imf_13 exp_imf_14 exp_imf_4 exp_imf_5 exp_imf_6 exp_imf_7 exp_imf_8 exp_imf_9 exp_imf_econ1 exp_imf_econ2 exp_imf_econ4 exp_imf_econ6 exp_imf_econ3-2 exp_imf_econ7-2 exp_imf_econ7-1-1 exp_imf_econ3-5 exp_imf_econ3-3-4 exp_imf_econ3-1 exp_imf_1-3 exp_imf_1-2 exp_imf_1-1 exp_imf_econ7-1 exp_imf_econ3 exp_imf_econ7 exp_imf_econI exp_imf_econII{; 
/* mit neuem mergen */
use "stata/stata_new.dta";
merge  countrycode year using "data_merged/`VariablenNamen'.dta",
sort;
codebook _merge;
drop _merge;
save "stata/stata_new.dta", replace;

}; /* Ende loop */




/*  ********************************************************************** */
/* log herstellen / Daten sichern*/
/*  ********************************************************************** */


translate stata/statalog.smcl stata/statalog.smcl.ps, replace translator(smcl2ps) headertext(on) pagesize(A4);

/* translate stata/statalog.smclstata/statalog.smcl.pdf, replace translator(smcl2pdf); */

translate stata/statalog.smcl stata/statalog.smcl.txt, replace translator(smcl2txt); 



/* beende das loggen (capture unterdrueckt output) */
log close;


clear;

/* exit; */




